import { IAnimateOption, IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class FillModel extends BaseModel {
    private meter2coord;
    private meteryScale;
    private isMeter;
    private unit;
    getUninforms(): IModelUniform;
    getAnimateUniforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(callbackModel: (models: IModel[]) => void): void;
    /**
     * 计算等面积点图层（unit meter）笛卡尔坐标标度与世界坐标标度的比例
     * @returns
     */
    calMeter2Coord(): void;
    buildModels(callbackModel: (models: IModel[]) => void): Promise<void>;
    /**
     * 根据 animateOption 的值返回对应的 shader 代码
     * @returns
     */
    getShaders(animateOption: Partial<IAnimateOption>): {
        frag: string;
        vert: string;
        type: string;
    };
    clearModels(): void;
    protected animateOption2Array(option: Partial<IAnimateOption>): number[];
    protected registerBuiltinAttributes(): void;
    /**
     * 判断是否更新点图层的计量单位
     * @param unit
     */
    private updateUnit;
}
