"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inversify = require("inversify");

require("reflect-metadata");

var _dec, _class;

var LayerModelPlugin = (_dec = (0, _inversify.injectable)(), _dec(_class = function () {
  function LayerModelPlugin() {
    (0, _classCallCheck2.default)(this, LayerModelPlugin);
  }

  (0, _createClass2.default)(LayerModelPlugin, [{
    key: "initLayerModel",
    value: function initLayerModel(layer) {
      layer.prepareBuildModel();
      layer.buildModels();
      layer.emit('modelLoaded', null);
      layer.styleNeedUpdate = false;
    }
  }, {
    key: "prepareLayerModel",
    value: function prepareLayerModel(layer) {
      layer.prepareBuildModel();
      layer.clearModels();
      layer.buildModels();
      layer.emit('modelLoaded', null);
      layer.layerModelNeedUpdate = false;
    }
  }, {
    key: "apply",
    value: function apply(layer) {
      var _this = this;

      layer.hooks.init.tap('LayerModelPlugin', function () {
        layer.inited = true;
        var source = layer.getSource();

        if (source.inited) {
          _this.initLayerModel(layer);
        }
      });
      layer.hooks.beforeRenderData.tap('DataSourcePlugin', function () {
        var source = layer.getSource();

        if (source.inited) {
          _this.prepareLayerModel(layer);
        } else {
          source.once('sourceUpdate', function () {
            _this.prepareLayerModel(layer);
          });
        }

        return false;
      });
    }
  }]);
  return LayerModelPlugin;
}()) || _class);
exports.default = LayerModelPlugin;
//# sourceMappingURL=LayerModelPlugin.js.map